"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const configuration_service_1 = require("../services/configuration.service");
const myEnergi_service_1 = require("./myEnergi.service");
// getting last vehicle data
const getConfData = (req, res, next) => __awaiter(void 0, void 0, void 0, function* () {
    var _a;
    if (!((_a = configuration_service_1.ConfigurationService.getConfiguration().myEnergi) === null || _a === void 0 ? void 0 : _a.useMyEnergi)) {
        return res.status(400).json({ error: 'can\'t get myEnergi data because configuration useMyEnergy parameter is false' });
    }
    let result = {};
    try {
        result = myEnergi_service_1.MyEnergiService.getConfData();
    }
    catch (e) {
        return res.status(500).json({ error: 'can\'t get tesla data' });
    }
    return res.status(200).json(result);
});
// setting a mode
const getChargingMode = (req, res, next) => __awaiter(void 0, void 0, void 0, function* () {
    var _b;
    if (!((_b = configuration_service_1.ConfigurationService.getConfiguration().myEnergi) === null || _b === void 0 ? void 0 : _b.useMyEnergi)) {
        return res.status(400).json({ error: 'can\'t get myEnergi data because configuration useMyEnergy parameter is false' });
    }
    let result = {};
    try {
        if (!req.query.chargingMode) {
            return res.status(400).json({ error: 'param chargingMode not found' });
        }
        // set charging mode
        let chargingMode = req.query.chargingMode;
        result = myEnergi_service_1.MyEnergiService.setMode(chargingMode);
    }
    catch (e) {
        return res.status(500).json({ error: 'can\'t set tesla charging mode' });
    }
    return res.status(200).json(result);
});
// getting last data
const getZappiData = (req, res, next) => __awaiter(void 0, void 0, void 0, function* () {
    var _c;
    if (!((_c = configuration_service_1.ConfigurationService.getConfiguration().myEnergi) === null || _c === void 0 ? void 0 : _c.useMyEnergi)) {
        return res.status(400).json({ error: 'can\'t get myEnergi data because configuration useMyEnergy parameter is false' });
    }
    let result = {};
    try {
        result = myEnergi_service_1.MyEnergiService.getZappiData();
    }
    catch (e) {
        return res.status(500).json({ error: 'can\'t get My Energy data' });
    }
    return res.status(200).json(result);
});
exports.default = {
    getChargingMode,
    getConfData,
    getZappiData,
};
