"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
/** source/routes/posts.ts */
const express_1 = __importDefault(require("express"));
const posts_1 = __importDefault(require("../controllers/posts"));
const enphase_controller_1 = __importDefault(require("../enphase/enphase.controller"));
const tesla_controller_1 = __importDefault(require("../tesla/tesla.controller"));
const myEnergy_controller_1 = __importDefault(require("../myEnergi/myEnergy.controller"));
const web_controller_1 = __importDefault(require("../web/web.controller"));
const tools_controller_1 = __importDefault(require("../tools/tools.controller"));
const router = express_1.default.Router();
router.get('/tools', tools_controller_1.default.get);
router.get('/production', enphase_controller_1.default.getProduction);
router.get('/productionForStep', enphase_controller_1.default.getProductionForStep);
router.get('/productionRealTime', enphase_controller_1.default.getProductionRealTime);
router.get('/productionRealTimeOneHour', enphase_controller_1.default.getProductionRealTimeOneHour);
router.get('/productionInverter', enphase_controller_1.default.getProductionInverter);
router.get('/importedForPrice', enphase_controller_1.default.getImportedForPrice);
router.get('/importedForPrices', enphase_controller_1.default.getImportedForPrices);
router.get('/testGateway', enphase_controller_1.default.testGateway);
router.get('/teslaData', tesla_controller_1.default.getLastData);
router.get('/teslaRefresh', tesla_controller_1.default.getRefresh);
router.get('/teslaMode', tesla_controller_1.default.getMode);
router.get('/teslaClimate', tesla_controller_1.default.getClimate);
router.get('/teslaCharge', tesla_controller_1.default.getCharge);
router.get('/myEnergiChargingMode', myEnergy_controller_1.default.getChargingMode);
router.get('/myEnergiConfData', myEnergy_controller_1.default.getConfData);
router.get('/myEnergiZappiData', myEnergy_controller_1.default.getZappiData);
router.post('/importFile', enphase_controller_1.default.postImportFile);
router.post('/saveConf', web_controller_1.default.postConf);
router.get('/checkPassword', web_controller_1.default.checkPassword);
router.get('*', web_controller_1.default.get);
router.get('/posts', posts_1.default.getPosts);
router.get('/posts/:id', posts_1.default.getPost);
router.put('/posts/:id', posts_1.default.updatePost);
router.delete('/posts/:id', posts_1.default.deletePost);
router.post('/posts', posts_1.default.addPost);
module.exports = router;
