"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs = require("fs");
const enphase_data_service_1 = require("../enphase/enphase.data.service");
const configuration_service_1 = require("../services/configuration.service");
const path = require('node:path');
// getting data
const get = (req, res, next) => __awaiter(void 0, void 0, void 0, function* () {
    // mode production
    if (req.url.endsWith('config.json')) {
        let str = fs.readFileSync('./assets/conf/config.json', 'utf8');
        let conf = JSON.parse(str);
        conf.enphase.token = '';
        conf.enphase.user = '';
        conf.enphase.password = '';
        conf.enphase.userEnphaseEnergy = '';
        conf.enphase.passwordEnphaseEnergy = '';
        conf.enphase.gatewaySerial = '';
        conf.tesla.token = '';
        if (conf.myEnergi === undefined) {
            conf.myEnergi = {};
        }
        conf.myEnergi.token = '';
        conf.myEnergi.serialNumber = '';
        conf.application.pwd = '';
        conf.startDate = enphase_data_service_1.EnphaseDataService.getStartTimestamp();
        return res.status(200).json(conf);
    }
    if (req.url === '/') {
        return res.status(200).sendFile(process.cwd() + '/webapp' + req.url + 'index.html');
    }
    else {
        return res.status(200).sendFile(process.cwd() + '/webapp' + req.url);
    }
});
// save configuration
const postConf = (req, res, next) => __awaiter(void 0, void 0, void 0, function* () {
    var _a;
    // get the data from req.body
    let conf = req.body;
    let attrib = '';
    if ((_a = req === null || req === void 0 ? void 0 : req.query) === null || _a === void 0 ? void 0 : _a.changedAttribut) {
        attrib = req.query.changedAttribut;
    }
    configuration_service_1.ConfigurationService.setConfiguration(conf, attrib, 'postConf');
    // return response
    return res.sendStatus(200);
});
const checkPassword = (req, res, next) => __awaiter(void 0, void 0, void 0, function* () {
    var _b;
    // get the data from req.body
    let conf = req.body;
    let pwd = '';
    if ((_b = req === null || req === void 0 ? void 0 : req.query) === null || _b === void 0 ? void 0 : _b.pwd) {
        pwd = req.query.pwd;
    }
    // console.log('ask if password (' + pwd + ') is correct (' + ConfigurationService.getConfiguration().application.pwd + ')');
    if (configuration_service_1.ConfigurationService.getConfiguration().application.pwd === pwd) {
        return res.sendStatus(200);
    }
    // return response
    return res.sendStatus(400);
});
exports.default = {
    get,
    postConf,
    checkPassword
};
